/**
 * 
 *
 * version : 2.0
 * last update : 2014/10/06
 **/

// 
oimc.rotationAll360 = oimc.rotationAll360 || {};

$(function(){
	// ------------------------------------------------------------------------
	// 
	// ------------------------------------------------------------------------

	var _config = {
		frames   : 24,
		cols     : 7,
		images   :'',
		startNum : 73,
		alt: ''
	}

	// default settings
	var _colsSpeed   = 20;
	var _framesSpeed = 15;

	// 
	var _colsNum = 0;
	var _frameNum = 0;
	var _$rat360BaseObj;
	var _$dataLi;
	var _imageGeneralArr = [];

	var _oldPt = {x:0, y:0 };

	// 
	var _beginTime;
	var _beginDownPt;
	var _endTime;
	var _endUpPt;
	var _inertiaCnt = 0;
	var _timerId = 0;

	function imageUrlgenerater( num ){
		num = num * 1;

		var resultNumStr = '';
		var resultUrlStr = _$dataLi.eq(num-1).find('img').attr('src');

		return resultUrlStr;
	}


	function init(){
		_$rat360BaseObj = $('.boxAll360View');
		_$dataLi = _$rat360BaseObj.children('ul').children('li');

		// doCheck
		if( _$rat360BaseObj.length === 0 ){
			return;
		}

		// HACK: IE8
		if( uaNtv.ltIE8 ){
			$('.boxAll360View img').css({ cursor:'move' })
		};

		var w = _$rat360BaseObj.width();
		var h = _$rat360BaseObj.height();

		_$rat360BaseObj
			.css({ position:'relative', height:h })
			.empty();

		if(_$dataLi.length) {
			jsonParse();
		};
	}


	function jsonParse( data ){
		var _$startObj = _$dataLi.filter('.startNum');
		if(_$startObj.length) {
			_config.startNum = _$startObj.index() + 1;
		};
		_config.alt = _$dataLi.first().find('img').attr('alt');

		rat360LoadingImgAdd();
	}

	function rat360LoadingImgAdd(){
		// loading img
		_$loadingObj = $('<div id="loadingPart" style="width:100%; text-align: center; position:relative; opacity:0;"><img src="/content/000000016.gif" style="opacity:1;"></div>');
		_$rat360BaseObj.append( _$loadingObj );
		$('.boxAll360View > div > img').css({ 'opacity': 1 })

		// cursor
		$('.boxAll360View img').css({ cursor:'auto' })

		_$loadingObj.ready(function() {
			_$rat360BaseObj.find('#loadingPart')
				.stop()
				.css({ top: _$rat360BaseObj.height() / 2 - 30 })
				.animate({
					opacity:1
				},{
					duration:600,
					complete: imageLoad
				});
		});
	}

	function imageLoad(){
		var tempCnt = 0;

		// 
		for(var i = 1; i <= _config.cols; i++){
			var tempArr = [];
			for(var j = 1; j <= _config.frames; j++){

				var imageUrl = imageUrlgenerater( ++tempCnt );
				tempArr.push( imageUrl );

				// startImage
				if( tempCnt === _config.startNum ){
					_colsNum = i - 1;
					_frameNum = j - 1;
				}
			}
			_imageGeneralArr.push( tempArr );
		}

		tempCnt = 0;

		// 
		var loadedCounter = 0;
		var len = _config.cols * _config.frames;
		loadImge();

		function loadImge() {
			var imgObj = new Image();

			$( imgObj ).bind("load",
				function(){
					loadedCounter++;

					if ( loadedCounter === len ) {
						// loading
						$('#loadingPart')
							.stop()
							.animate({
								opacity:0
							},{
								duration:400,
								complete: function(){
									$(this).remove();
									show();
								}
							});
					} else {
						loadImge();
					}
				});

			var imageUrl = imageUrlgenerater( ++tempCnt );
			imgObj.src = imageUrl;
		};
	}

	function show(){
		// 
		_$rat360BaseObj.append('<img src="/content/000024687.png" style="opacity:0; position:absolute; z-index:51" id="rAll360iconCont">');

		// img
		_$rat360BaseObj
			.css({ height:'' })
			.append('<img src=' + imageUrlgenerater( _config.startNum ) + ' style="opacity:0; z-index:50" id="rAll360img" alt="' + _config.alt + '">')

		$ratImg = $('#rAll360img');

		// HACK: IE8
		if( uaNtv.ltIE8 ){
			$ratImg.css({ cursor:'move' })
		};

		// icon
		$(window).on('resize', rotate360RisizeHandler);
		iconAnimete();

		// begin!
		$ratImg
			.stop()
			.animate({
				opacity: 1
			},{
				duration: 400,
				complete: function(){
					$(this).on('mousedown', imageObjMouseDownHandler );
					$(this).on('touchstart', imageObjMouseDownHandler );
					$(document).on('keydown', keyboadEventHandler );
				}
			});

		// animate
		var cnt = 0;
		setTimeout(showAnimate, 10)

		function showAnimate(){
			cnt++;

			if( cnt > _config.frames ){
				return;
			}

			_frameNum = frameNumCheck( ++_frameNum );
			imageChange();
			setTimeout(showAnimate, 2 + Math.floor(cnt * 1.5 ))
		}
	}

	function iconAnimete(){
		if( $('#rAll360iconCont').length === 0 ){
			return;
		};

		var boxW = _$rat360BaseObj.css('width').replace('px', '') * 1;
		var boxH = _$rat360BaseObj.find('#rAll360img').css('height').replace('px', '') * 1;
		var iconW = 100;

		_$rat360BaseObj.find('#rAll360iconCont').css({});

		// icon
		_$rat360BaseObj
			.find('#rAll360iconCont')
			.delay(650)
			.stop()
			.css({ top:50, left:(boxW + iconW) / 2 - 100, opacity:0 })
			.animate({
				opacity:1,
				top : boxH - 60
			},{
				duration: 500,
				easing: 'easeOutBack'
			});
	};

	function iconRemove(){
		// icon
		var $icon = $('#rAll360iconCont');

		if( $icon.length > 0){
			$icon.stop()
				.animate({
					opacity:0
				},{
					duration:500,
					complete:function(){
						$icon.remove();
					}
				});
		};
	}

	function rotate360RisizeHandler(){
		$(window).off('resize', rotate360RisizeHandler)

		if( $('#rAll360iconCont').length === 0 ){
			return;
		};

		var boxW = _$rat360BaseObj.css('width').replace('px', '') * 1;
		var boxH = _$rat360BaseObj.find('#rAll360img').css('height').replace('px', '') * 1;
		var iconW = 100;

		_$rat360BaseObj.find('#rAll360iconCont')
			.stop()
			.css({ top:50, top : boxH - 10, left:(boxW + iconW) / 2 - 100 });

		setTimeout(function(){
			$(window).on('resize', rotate360RisizeHandler)
		}, 30);
	}

	function imageObjMouseDownHandler(e) {
		e.preventDefault();

		_oldPt.x = e.clientX || e.originalEvent.changedTouches[0].pageX;
		_oldPt.y = e.clientY || e.originalEvent.changedTouches[0].pageY;

		iconRemove();

		// HACK: IE8
		if( !uaNtv.ltIE8 ){
			// cursol
			$ratImg.css({ 'cursor': 'url(/content/000024684.cur), url(/assets/img/img_grab_02.png), move' });
			$('.boxAll360View').css({ 'cursor': 'url(/content/000024684.cur), url(/assets/img/img_grab_02.png), move' });
		};

		// 
		_beginTime = new Date();
		_beginDownPt = e.pageX || e.originalEvent.changedTouches[0].pageX;
		if( _timerId !== 0 ){ clearTimeout( _timerId ); }

		// event
		$(document).on('mouseup', imageContainerMouseUpHandler);
		_$rat360BaseObj.on('mousemove', imageContainerMouseMoveHandler);
		$(document).on('touchend', imageContainerMouseUpHandler );
		_$rat360BaseObj.on('touchmove', imageContainerMouseMoveHandler );
	}

	function imageContainerMouseMoveHandler(e) {
		e.preventDefault();

		var nowPt = {
			x : e.clientX || e.originalEvent.changedTouches[0].pageX,
			y : e.clientY || e.originalEvent.changedTouches[0].pageY
		};

		var flg = false;

		// ptY check
		if( nowPt.y - _oldPt.y <= -_colsSpeed ){

			_colsNum = colNumCheck( --_colsNum );
			_oldPt.y = nowPt.y;
			flg = true;

		}else if( nowPt.y - _oldPt.y >= _colsSpeed ){

			_colsNum = colNumCheck( ++_colsNum );
			_oldPt.y = nowPt.y;
			flg = true;
		}

		// ptX check
		if( nowPt.x - _oldPt.x <= -_framesSpeed ){

			_frameNum = frameNumCheck( --_frameNum );
			_oldPt.x = nowPt.x;
			flg = true;

		}else if( nowPt.x - _oldPt.x >= _framesSpeed ){

			_frameNum = frameNumCheck( ++_frameNum );
			_oldPt.x = nowPt.x;
			flg = true;

		}

		if( flg ){
			imageChange();
		}
	}

	function imageContainerMouseUpHandler(e) {
		// HACK: IE8
		if( !uaNtv.ltIE8 ){
			// cursol
			$ratImg.css({ 'cursor': 'url(/content/000000035.cur), url(/content/000000036.png), move' });
			$('.boxAll360View').css({ 'cursor': '' });
		};

		// event remove
		$(document).off('mouseup', imageContainerMouseUpHandler);
		_$rat360BaseObj.off('mousemove', imageContainerMouseMoveHandler);
		$(document).off('touchend', imageContainerMouseUpHandler );
		_$rat360BaseObj.off('touchmove', imageContainerMouseMoveHandler );

		// 
		_endTime = new Date();
		_endUpPt = e.pageX || e.originalEvent.changedTouches[0].pageX;

		/*
		var valueTime = _endTime - _beginTime;
		var valueDist = Math.abs(_endUpPt - _beginDownPt);

		if( valueTime > 30 && valueTime < 300 && valueDist > 50 ){
			_inertiaCnt = 0;
			rotationInertia();
		};
		*/
	}

	function rotationInertia(){
		if( _inertiaCnt >= 10 ){
			_inertiaCnt = 0;
			_timerId = 0;
		} else {
			_inertiaCnt++;
			_timerId = setTimeout( function(){
				var num = 0;

				if( (_endUpPt - _beginDownPt) < 0) {
					num = +1;
				} else {
					num = -1;
				}

				rotationSetTimeout(num);
			}, 5 + _inertiaCnt + 2);
		};
	};

	function rotationSetTimeout( num ){
		_frameNum -= num
		frameNumCheck( _frameNum );
		imageChange();

		rotationInertia();
	}

	function imageChange() {
		var imageUrl = _imageGeneralArr[_colsNum][_frameNum];
		$('#rAll360img').attr({ src: imageUrl });
	}

	function keyboadEventHandler(e) {
		// icon
		var $icon = $('#rAll360iconCont');

		if( $icon.length > 0){
			$icon.stop()
				.animate({
					opacity:0
				},{
					duration:500,
					complete:function(){
						$icon.remove();
					}
				});
		};

		var keyCode = e.keyCode;
		var arrow = {left: 37, up: 38, right: 39, down: 40 };
		var flg = false;

		if( keyCode === arrow.left ){
			_frameNum = frameNumCheck( --_frameNum );
			flg = true;
		} else if( keyCode === arrow.right ){
			_frameNum = frameNumCheck( ++_frameNum );
			flg = true;
		} else if( keyCode === arrow.up ){
			_colsNum = colNumCheck( --_colsNum );
			flg = true;
		} else if( keyCode === arrow.down ){
			_colsNum = colNumCheck( ++_colsNum );
			flg = true;
		} else {
			return;
		};

		if( flg ){
			e.preventDefault();
			imageChange();
		}
	};

	function frameNumCheck( num ){
		if( num < 0){
			num = _config.frames - 1;
		}else if( num >= _config.frames ){
			num = 0
		}

		return num;
	}

	function colNumCheck( num ){
		if( num < 0){
			num = 0;
		}else if( num >= _config.cols ){
			num = _config.cols - 1;
		}

		return num;
	}

	$(window).on('load', init);
});